function RL = RL_PHASEII(mu,SIG1,X_II,h,k)
%RL       run length
%mu       IC mean 
%SIG1     IC correlation structure
%X_II     online data
%h        control limit
%k        the CUSUM parameter
pmax=length(SIG1)-1;
sig=sqrt(SIG1(1,1));
j=1;
C=0;
while (C<=h)&&(j<=length(X_II))
    if (C==0)
        C1=max([0,(X_II(j)-mu)/sig-k]);
        C2=min([0,(X_II(j)-mu)/sig+k]);
        C=max(C1,-C2);
        if C==0
            p=0;
        else
            p=1;
        end
        j=j+1;
        continue
    else
        SIG_jm1=SIG1(1:p,1:p);   %\SIGMA_{j-1,j-1}
        sig_jm1=SIG1(1:p,p+1);   %\bm\sigma_{j-1,j}
        obs_new=(X_II(j)-mu-sig_jm1'/SIG_jm1*(X_II(j-p:j-1)'-mu))...
                /sqrt(sig^2-sig_jm1'/SIG_jm1*sig_jm1);
        C1=max([0,C1+obs_new-k]);   
        C2=min([0,C2+obs_new+k]);
        C=max(C1,-C2);
        if C~=0
            p=min([p+1,pmax]);
        end
        j=j+1;
        continue
    end
end
RL=j-1;
end

